#include <windows.h>
#include <stdio.h>
#include <topic.cpp>
#include <discipline.cpp>
#include <screen.cpp>

#define WINDOW_NAME "AskMe 2.0"
#define BASE_PATH "Base\\"
#define MASK "*.txt"
#define STAT_STR_SIZE 48
#define TITLE_SIZE 1024
#define DSCPLN_NUMBER 64
#define TOPICS_NUMBER 128
#define Q_NUMBER 1024
#define VENTRY_NUMBER 64
#define LEFT_MAX (VENTRY_NUMBER/2-1)
#define LEFT_START 0
#define RIGHT_START VENTRY_NUMBER/2

#define ID_MENUABOUT 10
#define ID_MENUINFO 11
#define ID_MENUHOTKEYS 12
#define ID_MENUDISCIPLINE 20
#define ID_TOPIC 100
#define ID_OWNEDOK 200
#define ID_MAINOK 300
#define ID_VARIANTSTART 1000
#define ID_NUM 10000

#define Y_START 10
#define MENU_HEIGHT 60
#define TOPIC_WIDTH 250
#define TOPIC_HEIGHT 60
#define TOPIC_COLUMNS 3
#define VAR_HEIGHT 20
#define OKBUTTON_HEIGHT 30
#define WINDOWTITLE_HEIGHT 30
#define SPACER 15

LRESULT CALLBACK WndProc(HWND hWnd,UINT msg, WPARAM wParam,LPARAM lParam);
LRESULT CALLBACK OwnedProc(HWND hwnd, UINT Message, WPARAM wparam,LPARAM lparam);
void WM_PaintTask(HDC hDC);

void Init();
bool CreateMenuItem(HMENU hMenu, char* str, UINT uID, UINT wID, HMENU hSubMenu);
int PlaceQuestion2(int ToInsert, bool bReset);

//Screen OnScreen;
Screen2 OnScreen2;
HINSTANCE hInst;
HFONT hCorrect,hMissing,hExcessive;
int QCount=-1;
int nCycle=1;

HWND hOwned;
int nID=ID_VARIANTSTART;
float fChar_test;
TopicClass Topic_test;
DisciplineClass Discipline;

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int iCmdShow)
    {
    MSG msg;
    char ToSearch[PATH_SIZE];
    HMENU hMainMenu;
    HMENU hDscplnMenu;
    HMENU hHelpMenu;

    hInst=hInstance;
    Init();
OnScreen2.Init();
    sprintf(ToSearch, "%s%s", BASE_PATH, MASK);
    Discipline.LoadDisciplines(ToSearch);

    hMainMenu = CreateMenu();
    hDscplnMenu = CreatePopupMenu();
    hHelpMenu = CreatePopupMenu();
    for (int i=0;i<=Discipline.DCount_ext;i++)
    {
	OnScreen2.CreateMenuItem(hDscplnMenu, Discipline.Dscpln[i].title, 0, ID_MENUDISCIPLINE+i, NULL);
    }

    OnScreen2.CreateMenuItem(hHelpMenu, "О программе", 1, ID_MENUABOUT, NULL);
    OnScreen2.CreateMenuItem(hHelpMenu, "Горячие клавиши", 1, ID_MENUHOTKEYS, NULL);
    OnScreen2.CreateMenuItem(hHelpMenu, "База данных", 1, ID_MENUINFO, NULL);
    OnScreen2.CreateMenuItem(hMainMenu, "Дисциплины", 0, 0, hDscplnMenu);
    OnScreen2.CreateMenuItem(hMainMenu, "Помощь", 1, 0, hHelpMenu);

//    OnScreen.hWnd = CreateWindowEx
    OnScreen2.hWnd = CreateWindowEx
	(0,
	"MainWClass",
	WINDOW_NAME,
	WS_OVERLAPPEDWINDOW,
	CW_USEDEFAULT,
	CW_USEDEFAULT,
	CW_USEDEFAULT,
	CW_USEDEFAULT,
	(HWND) NULL,
	(HMENU) hMainMenu,
	hInstance,
	NULL);
//OnScreen2.hWnd=OnScreen.hWnd;
//    ShowWindow(OnScreen.hWnd,SW_MAXIMIZE);
//    UpdateWindow(OnScreen.hWnd);
    ShowWindow(OnScreen2.hWnd,SW_MAXIMIZE);
    UpdateWindow(OnScreen2.hWnd);

    TEXTMETRIC tmTM;
//    GetClientRect(OnScreen.hWnd,&OnScreen.rMainWindow);
//    HDC hDC=GetDC(OnScreen.hWnd);
    GetClientRect(OnScreen2.hWnd,&OnScreen2.rMainWindow);
    HDC hDC=GetDC(OnScreen2.hWnd);
    GetTextMetrics(hDC,&tmTM);
//    ReleaseDC(OnScreen.hWnd,hDC);
    ReleaseDC(OnScreen2.hWnd,hDC);
//    OnScreen.tmAveCharWidth=tmTM.tmAveCharWidth;
    OnScreen2.tmAveCharWidth=tmTM.tmAveCharWidth;

//    fChar_test=OnScreen.rMainWindow.right/2;
//    fChar_test=fChar_test/OnScreen.tmAveCharWidth;
    fChar_test=OnScreen2.rMainWindow.right/2;
    fChar_test=fChar_test/OnScreen2.tmAveCharWidth;
//test
//char ct[3];
//sprintf(ct,"%d",Topic_test.length);
//MessageBox(OnScreen.hWnd,ct,"Горячие клавиши",MB_OK|MB_ICONINFORMATION|MB_APPLMODAL);
    ACCEL acc[VAR_NUMBER+2];
    acc[0].key='1';
    for(int i=0;i<VAR_NUMBER;i++)
    {
	acc[i].cmd = ID_NUM+i;
	acc[i].fVirt = (BYTE)NULL;
	acc[i].key=acc[0].key+i;
    }
    acc[VAR_NUMBER].cmd = ID_MAINOK;
    acc[VAR_NUMBER].fVirt = (BYTE)NULL;
    acc[VAR_NUMBER].key = (char)13;

    acc[VAR_NUMBER+1].cmd = ID_MAINOK;
    acc[VAR_NUMBER+1].fVirt = (BYTE)NULL;
    acc[VAR_NUMBER+1].key = (char)32;

    HACCEL hAccel = CreateAcceleratorTable((LPACCEL)acc, VAR_NUMBER+2);

while(GetMessage(&msg,NULL,0,0))
    {
//	if(!(hAccel && TranslateAccelerator(OnScreen.hWnd, hAccel, &msg)))
	if(!(hAccel && TranslateAccelerator(OnScreen2.hWnd, hAccel, &msg)))
	{
	TranslateMessage(&msg);
	DispatchMessage(&msg);
	}
    }
    DestroyAcceleratorTable(hAccel);
    return msg.wParam;
    }

LRESULT CALLBACK WndProc (HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
static int QCurrent=0;
static bool bFirst=TRUE;

switch(msg)
{
case WM_PAINT:
{
	HDC hDC;
	PAINTSTRUCT ps;
	hDC=BeginPaint(OnScreen2.hWnd,&ps);
//	OnScreen.WM_PaintTask(hDC);
//	OnScreen.WM_PaintTask(hDC);
	WM_PaintTask(hDC);
	EndPaint(OnScreen2.hWnd,&ps);
}
break;

case WM_COMMAND:
{
    for(int i=0;i<=DSCPLN_NUMBER;i++)
    {
	if((LOWORD(wParam)==ID_MENUDISCIPLINE+i)&&(Discipline.Dscpln[i].loaded))
	{
	Discipline.UnloadTopics();
	Discipline.LoadTopics(Discipline.Dscpln[i]);
//	Discipline.DrawChooser(hInst, OnScreen.hWnd, hOwned, OnScreen.rMainWindow.bottom, OnScreen.rMainWindow.right, Discipline.Dscpln[i].path);
	Discipline.DrawChooser(hInst, OnScreen2.hWnd, hOwned, OnScreen2.rMainWindow.bottom, OnScreen2.rMainWindow.right, Discipline.Dscpln[i].path);
	}
    }

for(int i=0;i<VAR_NUMBER;i++)
{
	if((LOWORD(wParam)==ID_NUM+i)&&(bFirst))
	{
	int nIDComponent=Topic_test.GetIDComponent(QCurrent);
	for(int j=0;j<VAR_NUMBER;j++)
	{
		if((Topic_test.Get(QCurrent)->variant[j].loaded)&&(i==j))
		{
		HWND hwndCheck = GetDlgItem(hWnd, ID_VARIANTSTART+nIDComponent+j);
		LRESULT res = SendMessage (hwndCheck, BM_GETCHECK, 0, 0);
		if(res == BST_CHECKED) SendMessage (hwndCheck, BM_SETCHECK, BST_UNCHECKED, 0);
		else SendMessage (hwndCheck, BM_SETCHECK, BST_CHECKED, 0);
		}
	}
	}
}

if(!bFirst)
{
int nIDComponent=Topic_test.GetIDComponent(QCurrent);
for(int i=0;i<VAR_NUMBER;i++)
{
	if(LOWORD(wParam)==(ID_VARIANTSTART+nIDComponent+i))
	{
		HWND hwndCheck = GetDlgItem(hWnd, ID_VARIANTSTART+nIDComponent+i);
		LRESULT res = SendMessage (hwndCheck, BM_GETCHECK, 0, 0);
		if(res == BST_CHECKED) SendMessage (hwndCheck, BM_SETCHECK, BST_UNCHECKED, 0);
		else SendMessage (hwndCheck, BM_SETCHECK, BST_CHECKED, 0);
	}
}
}

if(LOWORD(wParam)==ID_MENUABOUT)
{
char s[]="Программа для подготовки к тестированию \"AskMe 2.0\".\nДомашняя страница: http://mmaketchup.narod.ru/additional.htm\nПрограмма распространяется по лицензии GPL\nПожелания и предложения напрявляйте на e-mail: mmaketchup@mail.ru.\n\nАвтор - Ketchup.\nСентябрь 2006.";
//MessageBox(OnScreen.hWnd,s,"О программе",MB_OK|MB_ICONINFORMATION|MB_APPLMODAL);
MessageBox(OnScreen2.hWnd,s,"О программе",MB_OK|MB_ICONINFORMATION|MB_APPLMODAL);
}

if(LOWORD(wParam)==ID_MENUHOTKEYS)
{
char s[]="Для выбора ответа используйте клавиши 1-7 на дополнительной (включите NumLock) или основной клавиатуре\nНажать кнопку \"OK\" можно пробелом или \"Enter\"";
//MessageBox(OnScreen.hWnd,s,"Горячие клавиши",MB_OK|MB_ICONINFORMATION|MB_APPLMODAL);
MessageBox(OnScreen2.hWnd,s,"Горячие клавиши",MB_OK|MB_ICONINFORMATION|MB_APPLMODAL);
}

if(LOWORD(wParam)==ID_MENUINFO)
{
char s[]="Формат базы:\nКаждый вопрос состоит из задания и вариантов ответа. На задание и варианты отводится по 1 строчке. Перед каждым вариантом стоит символ табуляции: (char)9\nКаждая дисциплина расположена в отдельной директории.\nОписание содержимого директории находится в файле \"Base\\x.txt\", где x - порядковый номер дисциплины\nВ файле-описании первая строчка отведена под название дисциплины. Далее идут строчки описания следующего формата: символ табуляции, затем название темы, далее в кавычках относительный путь к файлу с вопросами темы\nКодировка всех файлов: Windows-1251";
//MessageBox(OnScreen.hWnd,s,"Информация",MB_OK|MB_ICONINFORMATION|MB_APPLMODAL);
MessageBox(OnScreen2.hWnd,s,"Информация",MB_OK|MB_ICONINFORMATION|MB_APPLMODAL);
}

if (LOWORD(wParam)==ID_MAINOK)
{
static bool bOK=TRUE;
int nIDComponent=Topic_test.GetIDComponent(QCurrent);
//bOK=TRUE;
	for(int i=0;i<VAR_NUMBER;i++)
	{
	if(Topic_test.Get(QCurrent)->variant[i].loaded)
	{
		HWND hwndCheck = GetDlgItem(hWnd, ID_VARIANTSTART+nIDComponent+i);
		if(bFirst)
		{
		LRESULT res = SendMessage (hwndCheck, BM_GETCHECK, 0, 0);
		if((res == BST_CHECKED)&&(Topic_test.Get(QCurrent)->variant[i].correct))
			{SendMessage (hwndCheck, WM_SETFONT, (WPARAM)OnScreen2.hCorrect, 1);}
//			{SendMessage (hwndCheck, WM_SETFONT, (WPARAM)hCorrect, 1);}
		if((res == BST_CHECKED)&&(!Topic_test.Get(QCurrent)->variant[i].correct))
			{bOK=FALSE;SendMessage (hwndCheck, WM_SETFONT, (WPARAM)OnScreen2.hExcessive, 1);}
//			{bOK=FALSE;SendMessage (hwndCheck, WM_SETFONT, (WPARAM)hExcessive, 1);}
		if((res == BST_UNCHECKED)&&(Topic_test.Get(QCurrent)->variant[i].correct))
			{bOK=FALSE;SendMessage (hwndCheck, WM_SETFONT, (WPARAM)OnScreen2.hMissing, 1);}
//			{bOK=FALSE;SendMessage (hwndCheck, WM_SETFONT, (WPARAM)hMissing, 1);}
		}
		else EnableWindow(hwndCheck,0);
	}
	}
	if((bOK)&&(bFirst)) {Topic_test.Get(QCurrent)->completed=TRUE;}
	if(bFirst) {
//Topic_test.GetStat(nCycle,0,OnScreen.hWnd);
Topic_test.GetStat(nCycle,0,OnScreen2.hWnd);
	}
	if(!bFirst)
	{
		bOK=TRUE;
QCurrent=Topic_test.GetNextQuestion(QCurrent+1);
		if(QCurrent==-1)
			{
nID=ID_VARIANTSTART-1;
//			Topic_test.GetStat(nCycle,1,OnScreen.hWnd);
			Topic_test.GetStat(nCycle,1,OnScreen2.hWnd);
			nCycle++;
//			OnScreen.HideAll();
//			OnScreen.RemoveInvisible();
			OnScreen2.HideAll();
			OnScreen2.RemoveInvisible();
//			SetWindowText(hWnd,WINDOW_NAME);
			SetWindowText(OnScreen2.hWnd,WINDOW_NAME);
QCurrent=Topic_test.GetNextQuestion(0);
			if(QCurrent==-1)
				{
				MessageBox(NULL,"Game over","Game over",MB_OK);
				nCycle=1;
				QCurrent=-1;
//				OnScreen.HideAll();
//				OnScreen.RemoveInvisible();
				OnScreen2.HideAll();
				OnScreen2.RemoveInvisible();
//				SetWindowText(hWnd,WINDOW_NAME);
				SetWindowText(OnScreen2.hWnd,WINDOW_NAME);
//Topic_test.UnloadQuestions();
//				UnloadQuestions();
//				UnloadTopics();
Discipline.UnloadTopics();
				}
			}
//		OnScreen.PlaceQuestion(QCurrent,0);
		PlaceQuestion2(QCurrent,0);
//		PlaceQuestion2(QCurrent,0);
	}
	bFirst=!bFirst;
}
return -1;
}

case (WM_USER):
{
//	OnScreen.HideAll();
//	OnScreen.RemoveInvisible();
//	OnScreen.Cleaner();
	OnScreen2.HideAll();
	OnScreen2.RemoveInvisible();
	OnScreen2.Cleaner();
	QCurrent=0;
	bFirst=TRUE;
//	SetWindowText(hWnd,WINDOW_NAME);
//	OnScreen.PlaceQuestion(QCurrent,1);
	SetWindowText(OnScreen2.hWnd,WINDOW_NAME);
	PlaceQuestion2(QCurrent,1);
}
break;

case WM_DESTROY:
PostQuitMessage(0);
break;

default:
return DefWindowProc(hWnd,msg,wParam,lParam);
}

return 0;
}

LRESULT CALLBACK OwnedProc (HWND hwnd, UINT Message, WPARAM wparam, LPARAM lparam)
{
switch (Message)
{

case WM_CREATE:
{
//	EnableWindow(OnScreen.hWnd,0);
//	EnableWindow(hwnd,1);
	EnableWindow(OnScreen2.hWnd,0);
	EnableWindow(OnScreen2.hWnd,1);
}
break;

case WM_COMMAND:
{
if(LOWORD(wparam)==ID_OWNEDOK)
{
bool bChosen=FALSE;
//MessageBox(OnScreen.hWnd,"test","Горячие клавиши",MB_OK|MB_ICONINFORMATION|MB_APPLMODAL);
for(int i=0;i<TOPICS_NUMBER;i++)
{
	if (Discipline.Topic[i].loaded)
	{
	HWND hwndCheck = GetDlgItem(hwnd, i+ID_TOPIC);
	LRESULT res = SendMessage (hwndCheck, BM_GETCHECK, 0, 0);
	if(res==BST_CHECKED)
	    {
	    Topic_test.UnloadQuestions();
	    Topic_test.LoadQuestions(Discipline.Topic[i].path);
    	    bChosen=TRUE;
//test
//char ct[3];
//sprintf(ct,"%d",i);
//MessageBox(OnScreen.hWnd,ct,"Горячие клавиши",MB_OK|MB_ICONINFORMATION|MB_APPLMODAL);
    	    }
	}
}

//if(bChosen) PostMessage(OnScreen.hWnd,WM_USER,0,0);
if(bChosen) PostMessage(OnScreen2.hWnd,WM_USER,0,0);
DestroyWindow(hwnd);
}
return -1;
}
break;

case WM_DESTROY:
{
//	EnableWindow(OnScreen.hWnd,1);
//	BringWindowToTop(OnScreen.hWnd);
	EnableWindow(OnScreen2.hWnd,1);
	BringWindowToTop(OnScreen2.hWnd);
	return 0;
}
break;

default:
	return DefWindowProc(hwnd,Message,wparam,lparam);
}
}

void Init()
{
WNDCLASSEX wc;
WNDCLASS w;

wc.cbSize=sizeof(wc);
wc.cbClsExtra=0;
wc.cbWndExtra=0;
wc.hbrBackground=(HBRUSH)COLOR_BTNSHADOW;
wc.hCursor=LoadCursor(0,IDC_ARROW);
wc.hIcon=LoadIcon(hInst,IDI_APPLICATION);
wc.hIconSm=LoadIcon(hInst,IDI_APPLICATION);
wc.hInstance=hInst;
wc.lpfnWndProc=WndProc;
wc.lpszClassName="MainWClass";
wc.lpszMenuName=NULL;
wc.style=CS_HREDRAW | CS_VREDRAW;
RegisterClassEx(&wc);

memset(&w,0,sizeof(WNDCLASS));
w.lpfnWndProc = OwnedProc;
w.hInstance = hInst;
w.hbrBackground = (HBRUSH)COLOR_BTNSHADOW;
w.lpszClassName = "OwnedWClass";
w.hCursor=LoadCursor(NULL,IDC_CROSS); 
RegisterClass(&w);
}

//void Screen::WM_PaintTask(HDC hDC)
void WM_PaintTask(HDC hDC)
    {
    SetBkMode(hDC,TRANSPARENT);
    for(int i=0;i<VENTRY_NUMBER;i++)
    {
    if(OnScreen2.Entry[i].visible)
    DrawText(
	hDC,
	Topic_test.Get(OnScreen2.Entry[i].qNumber)->task,
	strlen(Topic_test.Get(OnScreen2.Entry[i].qNumber)->task),
	&OnScreen2.Entry[i].task,
	DT_WORDBREAK);
    }
    }

int PlaceQuestion2(int ToInsert, bool bReset)
    {
    if(bReset) nID=ID_VARIANTSTART-1;

    RECT tmp;
    int nTaskHeight,nVariantsHeight,nVarCount=0,nIDComponent=0;
    HDC hDC;
    int nCoefficient=1;
    float fCoefficient,fChar;

    if(ToInsert==-1) return 0;

    tmp.left=0;
    tmp.right=OnScreen2.rMainWindow.right/2;
    tmp.top=0;
    tmp.bottom=SPACER;

    hDC=GetDC(OnScreen2.hWnd);
    DrawText(hDC, Topic_test.Get(ToInsert)->task, strlen(Topic_test.Get(ToInsert)->task), &tmp, DT_CALCRECT|DT_WORDBREAK);
    ReleaseDC(OnScreen2.hWnd,hDC);

    nTaskHeight=tmp.bottom-tmp.top;
    nTaskHeight+=SPACER;

    nVariantsHeight=0;
    for(int i=0;i<VAR_NUMBER;i++)
        {
        if(Topic_test.Get(ToInsert)->variant[i].loaded) 
        {nVariantsHeight+=Topic_test.Get(ToInsert)->variant[i].GetCoefficient(fChar_test)*VAR_HEIGHT;}
        }

    OnScreen2.CurrentPosition++;
    if(OnScreen2.CurrentPosition==VENTRY_NUMBER) {OnScreen2.CurrentPosition=0;}

    if(OnScreen2.CurrentPosition!=0)
    {
    if(
	(OnScreen2.Entry[OnScreen2.CurrentPosition-1].variants.bottom
	+nTaskHeight
	+nVariantsHeight
	+OKBUTTON_HEIGHT)
	>(OnScreen2.rMainWindow.bottom-Y_START))
	{if((OnScreen2.CurrentPosition<=LEFT_MAX)|(OnScreen2.CurrentPosition==RIGHT_START))
		{OnScreen2.CurrentPosition=RIGHT_START;}
	else OnScreen2.CurrentPosition=LEFT_START;}
    }

    if(OnScreen2.CurrentPosition!=0)
    {
    if((OnScreen2.Entry[OnScreen2.CurrentPosition-1].variants.bottom
	+nTaskHeight
	+nVariantsHeight
	+OKBUTTON_HEIGHT)<OnScreen2.Entry[OnScreen2.CurrentPosition].task.top)
	{OnScreen2.InsertPosition(OnScreen2.CurrentPosition);}
    }
    OnScreen2.Entry[OnScreen2.CurrentPosition].visible=FALSE;
    OnScreen2.RemoveInvisible();

    if((OnScreen2.CurrentPosition==LEFT_START)|(OnScreen2.CurrentPosition==RIGHT_START)) OnScreen2.Entry[OnScreen2.CurrentPosition].task.top=Y_START;
    else OnScreen2.Entry[OnScreen2.CurrentPosition].task.top=OnScreen2.Entry[OnScreen2.CurrentPosition-1].variants.bottom;

    OnScreen2.Entry[OnScreen2.CurrentPosition].task.bottom=OnScreen2.Entry[OnScreen2.CurrentPosition].task.top+nTaskHeight;
    OnScreen2.Entry[OnScreen2.CurrentPosition].variants.top=OnScreen2.Entry[OnScreen2.CurrentPosition].task.bottom;
    OnScreen2.Entry[OnScreen2.CurrentPosition].variants.bottom=OnScreen2.Entry[OnScreen2.CurrentPosition].variants.top+nVariantsHeight;

    if(OnScreen2.CurrentPosition<=LEFT_MAX)
    {
        OnScreen2.Entry[OnScreen2.CurrentPosition].task.left=OnScreen2.Entry[OnScreen2.CurrentPosition].variants.left=SPACER;
        OnScreen2.Entry[OnScreen2.CurrentPosition].task.right=OnScreen2.Entry[OnScreen2.CurrentPosition].variants.right=OnScreen2.rMainWindow.right/2;
    }
    else
    {
        OnScreen2.Entry[OnScreen2.CurrentPosition].task.left=OnScreen2.Entry[OnScreen2.CurrentPosition].variants.left=SPACER+OnScreen2.rMainWindow.right/2;
        OnScreen2.Entry[OnScreen2.CurrentPosition].task.right=OnScreen2.Entry[OnScreen2.CurrentPosition].variants.right=OnScreen2.rMainWindow.right;
    }

    OnScreen2.Entry[OnScreen2.CurrentPosition].visible=1;
    OnScreen2.Entry[OnScreen2.CurrentPosition].qNumber=ToInsert;

    for(int i=1;i<VENTRY_NUMBER/2;i++)
    {
	if(OnScreen2.CurrentPosition!=(VENTRY_NUMBER-i))
	{
	if
	(
		((OnScreen2.CurrentPosition<=LEFT_MAX)&&(OnScreen2.CurrentPosition+i)<=LEFT_MAX)|
		((OnScreen2.CurrentPosition>=RIGHT_START)&&(OnScreen2.CurrentPosition+i)>=RIGHT_START)
	)
	{
	if((OnScreen2.Entry[OnScreen2.CurrentPosition].variants.bottom+OKBUTTON_HEIGHT)>OnScreen2.Entry[OnScreen2.CurrentPosition+i].task.top)
		OnScreen2.Entry[OnScreen2.CurrentPosition+i].visible=FALSE;
	}
	}
    }
    OnScreen2.RemoveInvisible();

    hDC=GetDC(OnScreen2.hWnd);
    SetBkMode(hDC,TRANSPARENT);
    DrawText
	(hDC,
	Topic_test.Get(ToInsert)->task,
	strlen(Topic_test.Get(ToInsert)->task),
	&OnScreen2.Entry[OnScreen2.CurrentPosition].task,
	DT_WORDBREAK);
    ReleaseDC(OnScreen2.hWnd,hDC);

    for(int i=0;i<VAR_NUMBER;i++)
    {
	if(Topic_test.Get(OnScreen2.Entry[OnScreen2.CurrentPosition].qNumber)->variant[i].loaded)
	{
		if(Topic_test.Get(OnScreen2.Entry[OnScreen2.CurrentPosition].qNumber)->showed!=0)
		{
		nIDComponent=Topic_test.GetIDComponent(OnScreen2.Entry[OnScreen2.CurrentPosition].qNumber);
		nID=ID_VARIANTSTART-1+nIDComponent+nVarCount;
		}
	nID++;
	OnScreen2.Entry[OnScreen2.CurrentPosition].hVariant[i]=
		CreateWindow
		("button",
		Topic_test.Get(OnScreen2.Entry[OnScreen2.CurrentPosition].qNumber)->variant[i].text,
		WS_CHILD|WS_VISIBLE|BS_AUTOCHECKBOX|BS_MULTILINE,
		OnScreen2.Entry[OnScreen2.CurrentPosition].variants.left,
		OnScreen2.Entry[OnScreen2.CurrentPosition].variants.top+
		VAR_HEIGHT*Topic_test.Get(OnScreen2.Entry[OnScreen2.CurrentPosition].qNumber)->GetSumCoefficient(i,fChar_test),
		OnScreen2.Entry[OnScreen2.CurrentPosition].variants.right-OnScreen2.Entry[OnScreen2.CurrentPosition].variants.left,
		VAR_HEIGHT*Topic_test.Get(OnScreen2.Entry[OnScreen2.CurrentPosition].qNumber)->variant[i].GetCoefficient(fChar_test),
		OnScreen2.hWnd,
		(HMENU)nID,
		hInst,
		NULL);
	nVarCount++;
//test
//char ct[3];
//sprintf(ct,"%d;%d;%d",nID,nIDComponent,Entry[CurrentPosition].qNumber);
//MessageBox(OnScreen.hWnd,ct,"Горячие клавиши",MB_OK|MB_ICONINFORMATION|MB_APPLMODAL);
//sprintf(ct,"%d;%d;%d;(%d)",ToInsert,nIDComponent,Entry[CurrentPosition].qNumber,GetIDComponent(Entry[CurrentPosition].qNumber));
//MessageBox(OnScreen.hWnd,ct,"Горячие клавиши",MB_OK|MB_ICONINFORMATION|MB_APPLMODAL);
	}
    }
    OnScreen2.Entry[OnScreen2.CurrentPosition].hOK=CreateWindow(
	"button",
	"OK",
	WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
	OnScreen2.Entry[OnScreen2.CurrentPosition].variants.left,
	OnScreen2.Entry[OnScreen2.CurrentPosition].variants.top+
	VAR_HEIGHT*Topic_test.Get(OnScreen2.Entry[OnScreen2.CurrentPosition].qNumber)->GetSumCoefficient(nVarCount,fChar_test),
	OnScreen2.rMainWindow.right/2-2*SPACER,
	OKBUTTON_HEIGHT,
	OnScreen2.hWnd,
	(HMENU)ID_MAINOK,
	hInst,
	NULL);
    Topic_test.Get(OnScreen2.Entry[OnScreen2.CurrentPosition].qNumber)->showed++;
//test
//char ct[3];
//sprintf(ct,"%d",Question[Entry[CurrentPosition].qNumber].showed);
//SetWindowText(hWnd,ct);
    return 1;
    }
